//+------------------------------------------------------------------+
//|                                                  Power Trend.mq4 |
//|                  Copyright  2006,   . |
//|                                                khitenkov@mail.ru |
//+------------------------------------------------------------------+
#property copyright " Copyright  2006,   ."
#property link      "khitenkov@mail.ru"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_width1 3
#property indicator_color2 Red
#property indicator_width2 3
#property indicator_color3 RoyalBlue
#property indicator_width3 3
#property indicator_color4 HotPink
#property indicator_width4 3
 
//---- input parameters
extern int NumberOfBars=160; //   
extern int SmoothPeriod=7;   //  
extern int SmoothMode=1;     //  :MODE_SMA=0, MODE_EMA=1, MODE_SMMA=2, MODE_LWMA=3 
int Up=0;
int Down=0;
int MODE_FIRST=0;
int MODE_SECOND=1;
double f0=0;
double f1=0;
double s0=0;
double s1=0;
double sm0=0;
double sm1=0;
//---- indicator buffers
double UpBuffer[];
double DownBuffer[];
double UpUpBuffer[];
double DownDownBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
   string name; 
//---- line is when drawing
   SetIndexShift(0,Up);
   SetIndexShift(1,Down);
//---- first positions skipped when drawing
   SetIndexDrawBegin(0,Up);
   SetIndexDrawBegin(1,Down);
//---- 2 indicator buffers mapping
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DownBuffer);
   SetIndexBuffer(2,UpUpBuffer);
   SetIndexBuffer(3,DownDownBuffer);
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM,0,3);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,3);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,3);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,3);
//---- index labels
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2," ");
   SetIndexLabel(3," ");
//---- initialization done
    short_name="Power Trend Smoothed ";
    switch(SmoothMode)
      {
      case 0: name="SMA"; break;
      case 1: name="EMA"; break;
      case 2: name="SSMA"; break;
      case 3: name="LWMA"; break;
     }
   IndicatorShortName(short_name+name+"("+SmoothPeriod+")");
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Power Trend                                                      |
//+------------------------------------------------------------------+
int start()
  {
   double PrimaryBuffer[];
   double SmoothedBuffer[];
 
   int limit;
   ArrayInitialize(UpBuffer,0);
   ArrayInitialize(DownBuffer,0);
   ArrayInitialize(UpUpBuffer,0);
   ArrayInitialize(DownDownBuffer,0);
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
 
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=NumberOfBars;
   //Comment("Limit=",limit," Bars=",Bars);
   ArrayResize(PrimaryBuffer,limit);
   ArrayResize(SmoothedBuffer,limit);
   ArraySetAsSeries(PrimaryBuffer,true);
   ArraySetAsSeries(SmoothedBuffer,true);
//---- main loop
   for(int i=0; i<limit; i++)
   {
    f0 = iCustom(NULL, 0,"XX FATL",NumberOfBars,MODE_FIRST,i);
    f1 = iCustom(NULL, 0,"XX FATL",NumberOfBars,MODE_FIRST,i+1);
    s0 = iCustom(NULL, 0,"XX SATL",NumberOfBars,MODE_FIRST,i);
    s1 = iCustom(NULL, 0,"XX SATL",NumberOfBars,MODE_FIRST,i+1);
    sm0 = iCustom(NULL, 0,"XX",NumberOfBars,MODE_SECOND,i);
    sm1 = iCustom(NULL, 0,"XX",NumberOfBars,MODE_SECOND,i+1);
   PrimaryBuffer[i]=0;
    PrimaryBuffer[i]=PrimaryBuffer[i]+(f0-s0)/Point*9;
    PrimaryBuffer[i]=PrimaryBuffer[i]+(f0-f1)/Point*7;
    PrimaryBuffer[i]=PrimaryBuffer[i]+(sm0-sm1)/Point*3;
    PrimaryBuffer[i]=PrimaryBuffer[i]+(Close[i]-s0)/Point*3;
    PrimaryBuffer[i]=PrimaryBuffer[i]+(s0-s1)/Point;
   }
//---- 
   for (i=0; i<limit; i++) 
   {
   SmoothedBuffer[i]=iMAOnArray(PrimaryBuffer,Bars,SmoothPeriod,0,SmoothMode,i);
   if(SmoothedBuffer[i]>0 && SmoothedBuffer[i]>SmoothedBuffer[i+1]) {UpBuffer[i]=SmoothedBuffer[i];}
   if(SmoothedBuffer[i]<0 && SmoothedBuffer[i]<SmoothedBuffer[i+1]) {DownBuffer[i]=SmoothedBuffer[i];}
   if(SmoothedBuffer[i]<0 && SmoothedBuffer[i]>SmoothedBuffer[i+1]) {UpUpBuffer[i]=SmoothedBuffer[i];}
   if(SmoothedBuffer[i]>0 && SmoothedBuffer[i]<SmoothedBuffer[i+1]) {DownDownBuffer[i]=SmoothedBuffer[i];}
   }
//---- done
  return(0);
  }
//+------------------------------------------------------------------+

